// Mobjs
freeslot("MT_BACKGROUND", "MT_MIDGROUND", "MT_FOREGROUND")

// States

freeslot("S_BACKGROUND", "S_MIDGROUND", "S_FOREGROUND")

// Sprites

freeslot("SPR_BG", "SPR_MG", "SPR_FG")

states[S_BACKGROUND] = {
	sprite = SPR_BG,
	frame = A|FF_TRANSMASK,
	nextstate = S_BACKGROUND
}

states[S_FOREGROUND] = {
	sprite = SPR_FG,
	frame = A|FF_TRANSMASK,
	nextstate = S_FOREGROUND
}

mobjinfo[MT_BACKGROUND] = {
	doomednum = 2016,
	spawnstate = S_BACKGROUND,
	radius = 32*FU,
	height = 32*FU,
	flags = MF_SCENERY
}

mobjinfo[MT_FOREGROUND] = {
	doomednum = 2018,
	spawnstate = S_FOREGROUND,
	radius = 32*FU,
	height = 32*FU,
	flags = MF_SCENERY
}

addHook("MobjSpawn", function(mobj)
	if mobj and mobj.valid
		mobj.ground = 1
	end
end)

addHook("MobjMoveCollide", function(mobj, mo)
	if mobj and mobj.valid
	and mo and mo.valid
	and (twodlevel or (mo.flags2 & MF2_TWOD))
		mo.ground = $ - 1
		local x,y = cos(mo.angle),sin(mo.angle)
		P_MoveOrigin(mo, mo.x + -16*x, mo.y + -16*x, 0)
		print "worked"
	end
end, MT_BACKGROUND)

addHook("MobjMoveCollide", function(mobj, mo)
	if mobj and mobj.valid
	and mo and mo.valid
	and (twodlevel or (mo.flags2 & MF2_TWOD))
		mo.ground = $ + 1
		local x,y = cos(mo.angle),sin(mo.angle)
		P_MoveOrigin(mo, mo.x + 16*x, mo.y + 16*x, 0)
		print "worked"
	end
end, MT_FOREGROUND)

COM_AddCommand("2dnow", function(player)
	player.mo.flags2 = $|MF2_TWOD
end)